/**
* @file mc_drv.c
*
* Copyright (c) 2005 Atmel.
*
* @brief {BLDCmȂpʰ޳ ق񋟂܂B\n
* {͏ƌ`Ԑݒ܂݂܂B
* ʰ޳iɈˑ܂B
* @version 1.0 (CVS revision : $Revision: 1.4 $)
* @date $Date: 2006/07/12 12:58:27 $
* @author $Author: raubree $
*****************************************************************************/
#include "config.h"
#include "config_motor.h"

#include "mc_drv.h"
#include "mc_interface.h"
#include "mc_control.h"

#include "adc\adc_drv.h"
#include "dac\dac_drv.h"
#include "amplifier\amplifier_drv.h"
#include "pll\pll_drv.h"
#include "comparator\comparator_drv.h"

static U8 count = 1;						// countϐn̎ł̕ϑxvZɎgp܂B
static U16 average = 0;						//! x̕ϒl
static U8 ovf_timer = 0;					// ovf_timerϐ8ޯČv16ޯČvЭڰĂ̂Ɏgp܂B

static Bool g_mc_read_enable = FALSE;		// xǂݍ݉׸
Bool g_tick = FALSE;						//!< ̎l̐Ɏgp

static Bool delay_armed = FALSE;
static U8 delay_30d = 0;
volatile S16 comp_delay_30d = MIN_DELAY;
static U8 count_sub_tick = 8;
static U8 delay_mask = 0;

static S32 Num_turn = 0;					//! d@]̌vɎgp
static U8 hall_state = 0;

static char State = CONV_INIT;				//! A/Dϊv敔̏
static char ADC_State = FREE;				//! A/Dϊ̏: BUSY=sAFREE=񑖍s(~)

/******************************************************************************/
/******************************************************************************/
/*		ʰ޳														  */
/******************************************************************************/
/******************************************************************************/

/**
* @brief	ʰ޳(Ӌ@\)
* @pre		mc_init_port(), mc_init_pwm()...̑S֐ݒ
* @post		ʰ޳̏
*/
void mc_init_HW(void)
{
  mc_init_port();
  mc_init_IT();

  // : PWM̑OD/AϊƉߓd
  init_dac();
  mc_set_Over_Current(200);					// 51AA840A
  mc_init_pwm();

  mc_config_time_estimation_speed();
  mc_config_sampling_period();

  init_comparator0();
  init_comparator1();
  init_comparator2();
}

/**
* @brief	ĳ
* @pre		Ȃ
* @post		ĳ̏
*/
void mc_init_SW(void)
{
  Enable_interrupt();
}

/**
* @brief	AT90PWM3Bp̓o߰ď
* @pre		Ȃ
* @post		o߰Ă̏
*/
void mc_init_port(void)
{
  // o݌`Ԑݒ
  // PD0H_A, PB7L_A
  // PC0H_B, PB6L_B
  // PB0H_C, PB1L_C

  // PSCOUT`Ԑݒ(ύXs)
  // ߰B:
  DDRB = (1<<DDB7)|(1<<DDB6)|(1<<DDB3)|(1<<DDB1)|(1<<DDB0);
  // ߰C:
  DDRC = (1<<DDC0);
  // ߰D:
  DDRD = (1<<DDD0);


  // DDnx = 0:́A1:o (n=B,C,D,EAx=0,1,2,3,4,5,6,7)
  // PB3EXT1						PB4EXT2
  // PC1EXT3						PC2EXT4
  // PB5EXT5/POT					PE1EXT6
  // PD3EXT7/MOSI/LIN_TxD/TxD		PD4EXT8/MISO/LIN_RxD/RxD
  // PE0EXT9/NRES					PD2EXT10/MISO

  // ʰ޳ɏ]DDnxύX
  // ߰B:
  DDRB |= (0<<DDB5)|(1<<DDB4)|(0<<DDB3);
  // ߰C:
  DDRC |= (0<<DDC2)|(0<<DDC1);
  // ߰D:
  DDRD |= (0<<DDD4)|(0<<DDD3)|(0<<DDD2);	// UART̪܂JTAGICEmkUgpꍇɒ
  // ߰E:
  DDRE |= (1<<DDE2)|(0<<DDE1)|(0<<DDE0);	// PE0JTAGICEmkUɂĒ


  // MOS-FET쓮pxLowo
  PORTB &= ~(1<<PORTB7 | 1<<PORTB6 | 1<<PORTB3 |1<<PORTB1 | 1<<PORTB0);
  PORTC &= ~(1<<PORTC0);
  PORTD &= ~(1<<PORTD0);

  // ٱߊ
  PORTC |= (1<<PORTC6)|(1<<PORTC1);
  PORTD |= (1<<PORTD7)|(1<<PORTD5)|(1<<PORTD1);

  // 1p޼ٓ͋֎~
  // rp޼ٓ͂͋֎~܂B
  DIDR0 = (0<<ADC6D)|(0<<ADC3D)|(0<<ADC2D);
  DIDR1 = (0<<ACMP0D)|(0<<ACMP1D)|(1<<AMP1PD)|(1<<AMP1ND);
}

/**
* @brief	AT90PWM3BpPWM(PSC)
* @pre		Ȃ
* @post		d͒i(PSC)̏
*/
void mc_init_pwm()
{
  Start_pll_32_mega();
  Wait_pll_ready();

  // 񓮍:
  // PSCx_Init(Period_Half, Dutyx0_Half, Synchro, Dutyx1_Half)
#ifdef MCU_REV_B
  PSC0_Init(255,0,255,0);
  PSC1_Init(255,0,255,0);
  PSC2_Init(255,0,255,0);
#else
  PSC0_Init(255,0,1,0);
  PSC1_Init(255,0,1,0);
  PSC2_Init(255,0,1,0);
#endif
}

/**
* @brief	AT90PWM3BOݏ
* @pre		Ȃ
* @post		O(INT0,INT1,INT2,INT3)
*/
void mc_init_IT(void)
{
  EICRA =(0<<ISC21)|(1<<ISC20)|(0<<ISC11)|(1<<ISC10)|(0<<ISC01)|(1<<ISC00);
  EIFR = (1<<INTF2)|(1<<INTF1)|(1<<INTF0);	// `Ԑݒ̂߂ɉ\Ȋ荞݂
  EIMSK=(1<<INT2)|(1<<INT1)|(1<<INT0);
}

// PSC`ԂɉPSC
//  0- 1XΓ
//  1- 2XΓ
//  2- 4XΓ
//  3- 񓮍

/**
* @brief	PSC0PWM평
*/
void PSC0_Init ( unsigned int OCRnRB,
				 unsigned int OCRnSB,
				 unsigned int OCRnRA,
				 unsigned int OCRnSA)
{
  OCR0SAH = HIGH(OCRnSA);
  OCR0SAL = LOW(OCRnSA);
  OCR0RAH = HIGH(OCRnRA);
  OCR0RAL = LOW(OCRnRA);
  OCR0SBH = HIGH(OCRnSB);
  OCR0SBL = LOW(OCRnSB);
  OCR0RBH = HIGH(OCRnRB);
  OCR0RBL = LOW(OCRnRB);

  PCNF0 =  RAMP_MODE_NUMBER | (1<<PCLKSEL0) | OUTPUT_ACTIVE_HIGH ;
  /* ͂ƂPSC0Agp */
  PFRC0A = (1<<PELEV0A)|(1<<PFLTE0A)|(0<<PRFM0A3)|(1<<PRFM0A2)|(1<<PRFM0A1)|(1<<PRFM0A0);
//  PFRC0A = 0;
  PFRC0B = 0;
  PSOC0 = (1<<PSYNC00);								// (PSC̏㏸v)OCRnSAƂ̈vŐMo
  PCTL0 = (0<<PAOC0A)|(1<<PARUN0)|PRESC_DIV_BY_4;	/* AUTORUN !! */
}

/**
* @brief	PSC1PWM평
*/
void PSC1_Init ( unsigned int OCRnRB,
				 unsigned int OCRnSB,
				 unsigned int OCRnRA,
				 unsigned int OCRnSA)
{
  OCR1SAH = HIGH(OCRnSA);
  OCR1SAL = LOW(OCRnSA);
  OCR1RAH = HIGH(OCRnRA);
  OCR1RAL = LOW(OCRnRA);
  OCR1SBH = HIGH(OCRnSB);
  OCR1SBL = LOW(OCRnSB);
  OCR1RBH = HIGH(OCRnRB);
  OCR1RBL = LOW(OCRnRB);

  PCNF1 =  RAMP_MODE_NUMBER | (1<<PCLKSEL1) | OUTPUT_ACTIVE_HIGH ;
  PFRC1A = 0;
  PFRC1B = 0;
  PCTL1 = (0<<PAOC1A)|(1<<PARUN1)|PRESC_DIV_BY_4;	/* AUTORUN !! */
}

/**
* @brief	PSC2PWM평
*/
void PSC2_Init ( unsigned int OCRnRB,
				 unsigned int OCRnSB,
				 unsigned int OCRnRA,
				 unsigned int OCRnSA)
{
  OCR2SAH = HIGH(OCRnSA);
  OCR2SAL = LOW(OCRnSA);
  OCR2RAH = HIGH(OCRnRA);
  OCR2RAL = LOW(OCRnRA);
  OCR2SBH = HIGH(OCRnSB);
  OCR2SBL = LOW(OCRnSB);
  OCR2RBH = HIGH(OCRnRB);
  OCR2RBL = LOW(OCRnRB);

  PCNF2 =  RAMP_MODE_NUMBER | (1<<PCLKSEL2) | OUTPUT_ACTIVE_HIGH ;
  PFRC2A = 0;
  PFRC2B = 0;
//  PCTL2 = (0<<PAOC2A)|(1<<PRUN2)|PRESC_DIV_BY_4;	/* RUN !! */
}

/******************************************************************************/
/*		PSC~																  */
/******************************************************************************/
/* ̊֐PSC~܂B												  */
/******************************************************************************/
void PSC_Stop(void)
{
  Set_none();
  PCTL2 = (1<<PCCYC2);
}

/******************************************************************************/
/*		PSCs																  */
/******************************************************************************/
/* ̊֐PSCn܂B												  */
/******************************************************************************/
void PSC_Run(void)
{
  PCTL2 = (0<<PAOC2A)|(1<<PRUN2)|PRESC_DIV_BY_4;	/* RUN !! */
}

/***************************************************************************/
/***************************************************************************/
/*		d@̑(])pS֐									   */
/***************************************************************************/
/***************************************************************************/

/**
* @brief	ΰيm̒l(1`6)擾
* @param	unsigned char(ΰيm̒l)Ԃ܂B
* @pre		߰PBPĎ`Ԑݒ
* @post		ʒu̐Vl
*/
U8 mc_get_hall(void)
{
  return HALL_SENSOR_VALUE();				/* mL */
//  return ((~HALL_SENSOR_VALUE())&0x07);	/* mȂ */
}

/**
 * @brief	O (ΰيmAAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#pragma vector = HALL_A()
__interrupt void mc_hall_a(void)
{
  delay_armed = TRUE;
  delay_30d = comp_delay_30d;

  // ΰيmA̗オ[ł̐葬x
#ifdef USE_INTERNAL_COMPARATORS
  if (ACSR&(1<<AC0O))
#else
  if (PIND&(1<<PORTD7))
#endif
  {
	mc_estimation_speed();
	g_mc_read_enable=FALSE;		// ǂݍ1ҋ@ݒ
  }
  else
  {
	g_mc_read_enable=TRUE;
  }
  switch(hall_state)
  {
	case 2 : Num_turn++;break;
	case 3 : Num_turn--;break;
	default: break;
  }
  hall_state = 1;
}

/**
 * @brief	O (ΰيmBAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#pragma vector = HALL_B()
__interrupt void mc_hall_b(void)
{
  delay_armed = TRUE;
  delay_30d = comp_delay_30d;
  switch(hall_state)
  {
	case 1 : Num_turn--;break;
	case 3 : Num_turn++;break;
	default: break;
  }
  hall_state = 2;
}

 /**
 * @brief	O (ΰيmCAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#pragma vector = HALL_C()
__interrupt void mc_hall_c(void)
{
  delay_armed = TRUE;
  delay_30d = comp_delay_30d;
  switch(hall_state)
  {
	case 2 : Num_turn--;break;
	case 1 : Num_turn++;break;
	default: break;
  }
  hall_state = 3;
}

/**
* @brief	JԂɂČvZꂽlɏ]PSCޭè ْlݒ
*/
void mc_duty_cycle(U8 level)
{
  U8 duty;
  duty = level;

  PCNF0 = SET_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL0)|(1<<POP0);	/* PSC0Œ艻(ύXۗ) */
  PCNF1 = SET_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL1)|(1<<POP1);	/* PSC1Œ艻(ύXۗ) */
  PCNF2 = SET_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL2)|(1<<POP2);	/* PSC2Œ艻(ύXۗ) */

  // Duty=  0ޭè    0%
  // Duty=255ޭè  100%

  // PSCn0pޭè ِݒ
  OCR0SAH = 0;
  OCR0SAL = 255 - duty;

  OCR1SAH = 0;
  OCR1SAL = 255 - duty;

  OCR2SAH = 0;
  OCR2SAL = 255 - duty;

  // PWM헪ɏ]PSCn1pޭè ِݒ
  #ifdef HIGH_AND_LOW_PWM
  // HL̽PWM
	OCR0SBH = 0;
	OCR0SBL = 255 - duty  ;

	OCR1SBH = 0;
	OCR1SBL = 255 - duty  ;

	OCR2SBH = 0;
	OCR2SBL = 255 - duty  ;
  #else
  // PWMHɂ܂B
  // L100%ޭè (ᑬ)
	OCR0SBH = 0;
	OCR0SBL = 2;

	OCR1SBH = 0;
	OCR1SBL = 2;

	OCR2SBH = 0;
	OCR2SBL = 2;
  #endif

  Disable_interrupt();
  PCNF0 = RELEASE_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL0)|(1<<POP0);	/* PSC0Œ艻(ݒ蔽f) */
  PCNF1 = RELEASE_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL1)|(1<<POP1);	/* PSC1Œ艻(ݒ蔽f) */
  PCNF2 = RELEASE_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL2)|(1<<POP2);	/* PSC2Œ艻(ݒ蔽f) */
  Enable_interrupt();
}

/**
* @brief	m܂͐ʒuɏ]ďo͂ɐ؂ւ(])lݒ
*
* @param	ʒu(1`6)ƕ(FORWARD܂BACKWARD)
*/
void mc_switch_commutation(U8 position)
{
  // Ő(])邽߂ɓd@擾
  char direction = mci_get_motor_direction();

  // ͎gp҂d@nAxw肪0ƈقȂꍇɂ(])܂B
  if ((mci_motor_is_running()) && (mci_get_motor_speed()!=0))
  {
	mc_duty_cycle(mc_get_Duty_Cycle());
	switch(position)
	{
	// ]qʒuɏ]
	  case HS_001:	if (direction==CCW)	{Set_Q3Q2();}
					else				{Set_Q5Q2();}
					break;
	  case HS_101:	if (direction==CCW)	{Set_Q5Q2();}
					else				{Set_Q5Q4();}
					break;
	  case HS_100:	if (direction==CCW)	{Set_Q5Q4();}
					else				{Set_Q1Q4();}
					break;
	  case HS_110:	if (direction==CCW)	{Set_Q1Q4();}
					else				{Set_Q1Q6();}
					break;
	  case HS_010:	if (direction==CCW)	{Set_Q1Q6();}
					else				{Set_Q3Q6();}
					break;
	  case HS_011:	if (direction==CCW)	{Set_Q3Q6();}
					else				{Set_Q3Q2();}
					break;
	  default :		break;
	}
  }
  else
  {
	Set_none();		// SOFFɂ܂B
  }
}

/******************************************************************************/
/******************************************************************************/
/*		v1 : ̎掞Ԍ`Ԑݒ											  */
/******************************************************************************/
/******************************************************************************/

/**
 * @brief	v1`Ԑݒ
 * x̍̎p250sԊuł̊𐶐̂Ɏgp܂B
 * @pre		Ȃ
 * @post	256s̊荞
*/
void mc_config_sampling_period(void)
{
  TCCR1A = 0;								/* W߰ē,CTC */
  TCCR1B = 1<<WGM12 | 1<<CS11 | 1<<CS10 ;	/* CTC,64Ou(4s)Ŏn */
  TCCR1C = 0;
  OCR1AH = 0;								/* 31.25svlw */
  OCR1AL = 7;
  TIMSK1=(1<<OCIE1A);						/* rAv荞݋ */
}

/**
  * @brief	v1荞
  * v1͓d@ƎJԂpɎIȊ荞݂𐶐܂B
  * @pre	v1ڼ޽̌`Ԑݒ
  * @post	g_tickmain.cŒJԂɎgp܂B
*/
#pragma vector = TIMER1_COMPA_vect
__interrupt void timer1_periodic_interrupt(void)
{
  count_sub_tick --;
  if (count_sub_tick == 0)
  {
	g_tick = TRUE;
	count_sub_tick = 8;
  }

  if (delay_armed == TRUE)
  {
	delay_30d --;
	if (delay_30d == 0)
	{
	  delay_armed = FALSE;
	  delay_mask = MASK_DEMAG;
	  Disable_comparator0_interrupt();
	  Disable_comparator1_interrupt();
	  Disable_comparator2_interrupt();
	  mc_switch_commutation(HALL_SENSOR_VALUE());
	}
  }
  if (delay_mask != 0)
  {
	delay_mask --;
	if (delay_mask == 0)
	{
	  ACSR = (1<<AC2IF)|(1<<AC1IF)|(1<<AC0IF);
	  Enable_comparator0_interrupt();
	  Enable_comparator1_interrupt();
	  Enable_comparator2_interrupt();
	}
  }
}

/******************************************************************************/
/******************************************************************************/
/*		v0 : x													  */
/******************************************************************************/
/******************************************************************************/

/**
 * @brief	v0`Ԑݒ
 * v0͈ꔭɊԊuԂ𐶐̂Ɏgp܂B
 * @pre		Ȃ
 * @post	v0
*/
void mc_config_time_estimation_speed(void)
{
  TCCR0A = 0;
  TCCR0B = (0<<CS02)|(1<<CS01)|(1<<CS00);		// 64Ou(8s)Ŏn
  TIMSK0 = (1<<TOIE0);
}

/**
  * @brief	xpv0
  * @pre	v0̌`Ԑݒ
  * @post	d@x鎞Ɉ𐶐
*/
#pragma vector = TIMER0_OVF_vect
__interrupt void ovfl_timer(void)
{
  TCNT0=0x00;
  ovf_timer++;
  // 125msɐ(])Ȃꍇ
  // 125ms=(61<<8)*8s
  if(ovf_timer >= 100)
  {
	ovf_timer = 0;
	mci_store_measured_speed(0);
  }
}

/**
* @brief	x
* @pre		v0̌`Ԑݒ\n config_motor.hAVERAGE_SPEED_MEASURENT̗L`
* @post		xɊւVl
*/
void mc_estimation_speed(void)
{
  U16 timer_value;
  U32 new_measured_speed;

  if (g_mc_read_enable==OK)
  {
	// 8ޯĕϐTCNT0l16ޯČv̼ЭڰĂɎgp܂B
	timer_value = (ovf_timer<<8) + TCNT0;

	comp_delay_30d = (timer_value / 94) - FILTER_DELAY;						/* 30xvZ */
	if (comp_delay_30d < (S16)MIN_DELAY) comp_delay_30d = MIN_DELAY;		/* OaKp */
	else if (comp_delay_30d > (S16)MAX_DELAY) comp_delay_30d = MAX_DELAY;

	if (timer_value == 0) {timer_value += 1 ;}								// 0Zx
	new_measured_speed = K_SPEED / timer_value;
	if(new_measured_speed > 255) new_measured_speed = 255;					// ϐOa

	  // G邽߂ɕς8̎Ŏ܂B
	  average += new_measured_speed;
	  if(count >= 16)
	  {
		count = 1;
		mci_store_measured_speed(average >> 4);
		average = 0;
	  }
	  else count++;

	// v0ƕϐؾ
	TCNT0=0x00;
	ovf_timer = 0;
	g_mc_read_enable=KO;
  }
}

/******************************************************************************/
/******************************************************************************/
/*		A/Dϊ͓dƉϒȒɎgp								  */
/******************************************************************************/
/******************************************************************************/

/**
* @brief	dl𓾂邽߂ɍ̎菇Jn
* @pre		ƊԊuԂ̏
* @post		ϊI׸ސݒ
*/
#pragma vector = ADC_vect
__interrupt void ADC_EOC(void)
{
  if(State == CONV_CURRENT) mci_store_potentiometer_value(Adc_get_8_bits_result());
  if(State == CONV_POT) mci_store_measured_current(Adc_get_10_bits_result());
  ADC_State = FREE;
}

/**
* @brief	A/Dϊp̌v敔Jn
* @pre		Ȃ
* @post		ϒRƓd̒ľ(ch6ch12)擾
*/
void mc_ADC_Scheduler(void)
{
  switch(State)
  {
	case CONV_INIT :
	  init_adc();
	  init_amp1();
	  ADC_State = FREE;
	  State = CONV_POT;
	  break;

	case CONV_POT :
	  if(ADC_State == FREE)
	  {
		ADC_State = BUSY;
		State= CONV_CURRENT;
		Left_adjust_adc_result();
		Start_conv_channel(6);
	  }
	  break;

	 case CONV_CURRENT :
	  if(ADC_State == FREE)
	  {
		ADC_State = BUSY;
		State = CONV_POT;
		Right_adjust_adc_result();
		Start_amplified_conv_channel(12);
//		Start_conv_channel(9);
	  }
	  break;
  }
}

/******************************************************************************/
/******************************************************************************/
/*		ߓd`Ԑݒ														  */
/******************************************************************************/
/******************************************************************************/

/**
//! @brief	ߓd臒lݒ
//! @pre	D/Aϊ평
//! @post	ߓd臒lݒ肳܂B
*/
void mc_set_Over_Current(U8 Level)
{
  Set_dac_8_bits(Level);
}

/******************************************************************************/
/******************************************************************************/
/*		]擾															  */
/******************************************************************************/
/******************************************************************************/

/**
* @brief	]q]擾
* @pre		Ȃ
* @post		t32ޯẲ]擾
*/
S32 mc_get_Num_Turn()
{
  return Num_turn;
}

/**
* @brief	]q]ؾ
* @pre		Ȃ
* @post		]=0
*/
void mc_reset_Num_Turn()
{
  Num_turn = 0;
}
